if( !require('phaseR') ){
    install.packages('phaseR')
    library(phaseR)
}

my_yprime = function(t, y, parameters){
    x = y[1]
    y = y[2]
    dy = numeric(2)
    dy[1] = 1
    
    one_over_x = 1/(x+1.e-3)
    y_prime = -( exp(one_over_x) - cos(one_over_x)*y ) / ( x^2 * sin(one_over_x) )

    dy[2] = y_prime
    list( dy )
}

#postscript("../../WriteUp/Graphics/Chapter2/chap_2_sect_1_prob_26_plot.eps", onefile=FALSE, horizontal=FALSE)

diff_eq_params = c()

flowField(my_yprime, x.lim = c(1, 5), y.lim = c(-3, +6), parameters = diff_eq_params, points = 21, add = FALSE)
trajectory(my_yprime, y0 = c(1.0, -1), t.start=1, t.end = 5, parameters = diff_eq_params)
trajectory(my_yprime, y0 = c(1.0, +1), t.start=1, t.end = 5, parameters = diff_eq_params)
trajectory(my_yprime, y0 = c(1.0, +2), t.start=1, t.end = 5, parameters = diff_eq_params)
trajectory(my_yprime, y0 = c(1.0, +4), t.start=1, t.end = 5, parameters = diff_eq_params)

#dev.off()

