# I use the function knn.reg for simple comparisons below:
#
if( !require('FNN') ){
    install.packages("FNN", dependencies=TRUE, repos='http://cran.rstudio.com/')
}
library(FNN)

source('euler.R')


# Problem 16:
#
x_grid = c( 0.0, 0.1, 0.2, 0.5, 0.8, 1.0 )

dy.dx = function(x, y){ x^2 + y^2 }

h=0.1
res = euler(dy.dx, h=h, start=0, y0=1, end=1.0)
yhat_h1 = knn.reg( as.matrix( res$xs ), y=res$ys, test=as.matrix( x_grid ), k=1, algorithm='brute' )

h=0.05
res = euler(dy.dx, h=h, start=0, y0=1, end=1.0)
yhat_h2 = knn.reg( as.matrix( res$xs ), y=res$ys, test=as.matrix( x_grid ), k=1, algorithm='brute' )

h=0.025
res = euler(dy.dx, h=h, start=0, y0=1, end=1.0)
yhat_h3 = knn.reg( as.matrix( res$xs ), y=res$ys, test=as.matrix( x_grid ), k=1, algorithm='brute' )

h=0.01
res = euler(dy.dx, h=h, start=0, y0=1, end=1.0)
yhat_h4 = knn.reg( as.matrix( res$xs ), y=res$ys, test=as.matrix( x_grid ), k=1, algorithm='brute' )

A = rbind( yhat_h1$pred, yhat_h2$pred, yhat_h3$pred, yhat_h4$pred )
rownames(A) = NULL
R = cbind( c( 0.1, 0.05, 0.025, 0.01 ), A )
colnames(R) = c( 'h', sprintf( 'y(%.2f)', x_grid ) )
print('Problem 16:')
print(R)

