source('iterate_logistic.R')

rho = 1.2

# Part (a): u_0 < 0:
#
u0 = -0.75
us = iterate_logistic(rho, u0, N=5)

#postscript("../../WriteUp/Graphics/Chapter2/chap_2_sect_9_prob_16_part_a_stairstep.eps", onefile=FALSE, horizontal=FALSE)
un = seq( -5, 0, length.out=100 )
rhs = rho * un * ( 1 - un )
plot( un, rhs, type='l', xlab='u_n', ylab='u_{n+1}' )
lines( un, un, type='l', col='gray' )
lines( x=c( us[1], us[2], us[2], us[3], us[3] ), y=c( us[2], us[2], us[3], us[3], us[4] ), type='b', pch=19, col='black' )
grid()
#dev.off()


# Part (b): u_0 > 1:
#
u0 = 1.4
us = iterate_logistic(rho, u0, N=10)

#postscript("../../WriteUp/Graphics/Chapter2/chap_2_sect_9_prob_16_part_b_stairstep.eps", onefile=FALSE, horizontal=FALSE)
un = seq( -2, 3, length.out=100 )
rhs = rho * un * ( 1 - un )
plot( un, rhs, type='l', xlab='u_n', ylab='u_{n+1}' )
lines( un, un, type='l', col='gray' )
lines( x=c( us[1], us[2], us[2], us[3], us[3], us[4], us[4] ), y=c( us[2], us[2], us[3], us[3], us[4], us[4], us[5] ), type='b', pch=19, col='black' )
grid()
#dev.off()
