import sympy
from sympy import *

t, A4, A3, A2, A1, A0, B2, B1, B0, C, D = symbols('t A4 A3 A2 A1 A0 B2 B1 B0 C D')

Y = t * ( A4 * t**4 + A3 * t**3 + A2 * t**2 + A1 * t + A0 ) + t * ( B2 * t**2 + B1 * t + B0 ) * exp(-3*t) + C * sin(3 * t) + D * cos(3 * t) 

pt1 = diff(Y, t, 2)
pt2 = 3 * diff(Y, t, 1)
residual = ( pt1 + pt2 - 2 * t**4 - t**2 * exp(-3*t) - sin(3*t) ).expand()
print residual

# Output is (after regrouping):
#
# 3*A0 + 2*A1
# 
# + 6*A1*t + 6*A2*t
# 
# + 9*A2*t**2 + 12*A3*t**2
#
# + 12*A3*t**3 + 20*A4*t**3
#
# + 15*A4*t**4 - 2*t**4
#
# - 3*B0*exp(-3*t) + 2*B1*exp(-3*t)
# 
# - 6*B1*t*exp(-3*t) + 6*B2*t*exp(-3*t)
#
# - 9*B2*t**2*exp(-3*t) - t**2*exp(-3*t)
#
# - 9*C*sin(3*t) - 9*D*sin(3*t) - sin(3*t)
# 
# + 9*C*cos(3*t) - 9*D*cos(3*t)
#
