import sympy
from sympy import *

t, A, B, C1, C0, D1, D0 = symbols('t A B C1 C0 D1 D0')

Y = A * exp(t) * cos(2*t) + B * exp(t) * sin(2*t) + ( C1 * t + C0 ) * exp(2*t) * sin(t) + ( D1 * t + D0 ) * exp(2*t) * cos(t) 

pt1 = diff(Y, t, 2)
pt2 = - 5 * diff(Y, t, 1)
pt3 = 6 * Y
residual = ( pt1 + pt2 + pt3 - ( exp(t) * cos(2*t) + exp(2*t) * ( 3*t + 4 ) * sin(t) ) ).expand()
print residual

# Output is (after regrouping):
#
# 6*A*exp(t)*sin(2*t) - 2*B*exp(t)*sin(2*t)
# 
# - 2*A*exp(t)*cos(2*t) - 6*B*exp(t)*cos(2*t) - exp(t)*cos(2*t)
# 
# - C0*exp(2*t)*sin(t) - C1*exp(2*t)*sin(t) + D0*exp(2*t)*sin(t) - 2*D1*exp(2*t)*sin(t)- 4*exp(2*t)*sin(t)
# 
# - C0*exp(2*t)*cos(t) + 2*C1*exp(2*t)*cos(t) - D0*exp(2*t)*cos(t)- D1*exp(2*t)*cos(t)
# 
# - C1*t*exp(2*t)*sin(t) + D1*t*exp(2*t)*sin(t)- 3*t*exp(2*t)*sin(t)
# 
# - C1*t*exp(2*t)*cos(t) - D1*t*exp(2*t)*cos(t)
# 






