import sympy
from sympy import *

t, A, B2, B1, B0, C2, C1, C0 = symbols('t A B2 B1 B0 C2 C1 C0')

Y = A * exp(-t) + t * ( B2 * t**2 + B1 * t + B0 ) * exp(-t) * cos(t) + t * ( C2 * t**2 + C1 * t + C0 ) * exp(-t) * sin(t) 

pt1 = diff(Y, t, 2)
pt2 = 2 * diff(Y, t, 1)
pt3 = 2 * Y 
residual = ( pt1 + pt2 + pt3 - ( 3 * exp(-t) + 2 * exp(-t) * cos(t) + 4 * exp(-t) * t**2 * sin(t) ) ).expand()
print residual 

# Output is (after regrouping):
#
# A*exp(-t) - 3*exp(-t)
# 
# - 2*B0*exp(-t)*sin(t) + 2*C1*exp(-t)*sin(t)
# 
# + 2*B1*exp(-t)*cos(t) + 2*C0*exp(-t)*cos(t) - 2*exp(-t)*cos(t)
# 
# - 4*B1*t*exp(-t)*sin(t) + 6*C2*t*exp(-t)*sin(t)
#
# + 6*B2*t*exp(-t)*cos(t) + 4*C1*t*exp(-t)*cos(t)
#
# + 6*C2*t**2*exp(-t)*cos(t)
# 
# - 6*B2*t**2*exp(-t)*sin(t) - 4*t**2*exp(-t)*sin(t)
# 



