import sympy
from sympy import *

t, A2, A1, A0, B1, B0, C1, C0, D1, D0 = symbols('t A2 A1 A0 B1 B0 C1 C0 D1 D0')

Y = A2 * t**2 + A1 * t + A0 + t**2 * ( B1 * t + B0 ) * exp(2*t) + ( C1 * t + C0 ) * cos(2*t) + ( D1 * t + D0 ) * sin(2*t) 

pt1 = diff(Y, t, 2)
pt2 = -4 * diff(Y, t, 1)
pt3 = 4 * Y 
residual = ( pt1 + pt2 + pt3 - ( 2 * t**2 + 4 * t * exp(2*t) + t * sin(2*t) ) ).expand()
print residual

# Output is (after regrouping):
#
# 4*A0 - 4*A1 + 2*A2
# 
# + 4*A1*t - 8*A2*t
# 
# + 4*A2*t**2 - 2*t**2
# 
# + 2*B0*exp(2*t)
# 
# + 6*B1*t*exp(2*t) - 4*t*exp(2*t)
# 
# + 8*C0*sin(2*t) - 4*C1*sin(2*t) - 4*D1*sin(2*t)
# 
# - 4*C1*cos(2*t) - 8*D0*cos(2*t) + 4*D1*cos(2*t)
#  
# + 8*C1*t*sin(2*t) - t*sin(2*t)
#
# - 8*D1*t*cos(2*t)
# 







