import sympy
from sympy import *

t, A1, A0, B1, B0, C1, C0, D1, D0 = symbols('t A1 A0 B1 B0 C1 C0 D1 D0')

Y = t * ( A1 * t + A0 ) * exp(-t) * cos(2*t) + t * ( B1 * t + B0 ) * exp(-t) * sin(2*t) + ( C1 * t + C0 ) * exp(-2*t) * cos(t) + ( D1 * t + D0 ) * exp(-2*t) * sin(t) 

pt1 = diff(Y, t, 2)
pt2 = 2 * diff(Y, t, 1)
pt3 = 5 * Y 
residual = ( pt1 + pt2 + pt3 - ( 3 * t * exp(-t) * cos(2*t) - 2 * t * exp(-2*t) * cos(t) ) ).expand()
print residual 

# Output is (after regrouping):
#
# -4*A0*exp(-t)*sin(2*t) + 2*B1*exp(-t)*sin(2*t)
# 
# + 2*A1*exp(-t)*cos(2*t) + 4*B0*exp(-t)*cos(2*t)
# 
# - 8*A1*t*exp(-t)*sin(2*t)
# 
# + 8*B1*t*exp(-t)*cos(2*t) - 3*t*exp(-t)*cos(2*t) 
# 
# + 2*C1*t*exp(-2*t)*sin(t) + 4*D1*t*exp(-2*t)*sin(t)
# 
# + 2*C0*exp(-2*t)*sin(t) - 2*C1*exp(-2*t)*sin(t) + 4*D0*exp(-2*t)*sin(t) - 2*D1*exp(-2*t)*sin(t)
# 
# + 4*C0*exp(-2*t)*cos(t) - 2*C1*exp(-2*t)*cos(t) - 2*D0*exp(-2*t)*cos(t) + 2*D1*exp(-2*t)*cos(t)
# 
# + 2*t*exp(-2*t)*cos(t) + 4*C1*t*exp(-2*t)*cos(t) - 2*D1*t*exp(-2*t)*cos(t) 
# 



