u_exact = function(t, omega){
    ( 3/(1-omega^2) ) * ( cos(omega * t) - cos(t) )
}

ts = seq(0, 150, length.out=1000)

omegas = c(0.7, 0.8, 0.9)
US = c()
for( og in omegas ){
    us = u_exact(ts, og)
    US = cbind(US, us)
}

US_cp = US
dim(US_cp) = NULL
min_u = min(US_cp)
max_u = max(US_cp)

#postscript("../../WriteUp/Graphics/Chapter3/chap_3_sect_8_prob_18_plot.eps", onefile=FALSE, horizontal=FALSE)
matplot(ts, US, type='l', lty=1, xlab='t', ylab='u(t)', ylim=c(min_u, 42.0), main='u(0)=u_prime(0)=0')
grid()
legend('topleft', sprintf('omega= %.1f', omegas), lty=1, col=1:length(omegas))
#dev.off()
