library(deSolve)

dudt = function(t, state, parameters){
    with(as.list(c(state, parameters)),{
         du = uprime
         duprime = -4 * u - uprime / 8 + F0 * cos(omega*t)
         list(c(du, duprime))
    })
}

t = seq( 0, 60, length.out=1000 )

state = c( u=2, uprime=0 )


# Problem 21:
#
parms = c( F0=3, omega=0.25 )
res = ode(y=state, times=t, fun=dudt, parms=parms)
ts = res[,'time']
us_21 = res[,'u']
Fs_21 = parms['F0'] + cos(parms['omega'] * ts)


# Problem 22:
#
parms = c( F0=3, omega=2 )
res = ode(y=state, times=t, fun=dudt, parms=parms)
ts = res[,'time']
us_22 = res[,'u']
Fs_22 = parms['F0'] + cos(parms['omega'] * ts)


# Problem 23:
#
parms = c( F0=3, omega=6 )
res = ode(y=state, times=t, fun=dudt, parms=parms)
ts = res[,'time']
us_23 = res[,'u']
Fs_23 = parms['F0'] + cos(parms['omega'] * ts)


#postscript("../../WriteUp/Graphics/Chapter3/chap_3_sect_8_probs_21_23.eps", onefile=FALSE, horizontal=FALSE)

par(mfrow=c(1, 3))

y_min = min( c( us_21, Fs_21, us_22, Fs_22, us_23, Fs_23 ) )
y_max = max( c( us_21, Fs_21, us_22, Fs_22, us_23, Fs_23 ) )

plot(ts, Fs_21, col='black', type='l', ylim=c(y_min, y_max), xlab='t', ylab='')
lines(ts, us_21, col='blue', type='l')
grid()

plot(ts, Fs_22, col='black', type='l', ylim=c(y_min, y_max), xlab='t', ylab='')
lines(ts, us_22, col='blue', type='l')
grid()

plot(ts, Fs_23, col='black', type='l', ylim=c(y_min, y_max), xlab='t', ylab='')
lines(ts, us_23, col='blue', type='l')
grid()

par(mfrow=c(1, 1))

#dev.off()

