#
# xpdf ../../EBook/Elementary_Differential_Equations_10th_Edition.pdf 261 & 
#
import sympy
from sympy import *

t, A, B, C = symbols('t A B C')

y = A * t**2 + B * t + C * t * exp(t) 

pt1 = diff(y, t, 3)
pt2 = -3*diff(y, t, 2)
pt3 = 2*diff(y, t, 1)
residual = ( pt1 + pt2 + pt3 - ( t + exp(t) ) )
print(simplify(residual))

# Enforce the initial conditions:
# 
c1, c2, c3 = symbols('c1 c2 c3')

y = c1 + c2 * exp(t) + c3 * exp(2*t) + t**2 / 4 + 3 * t / 4 - t * exp(t)
print(y.subs(t, 0))
print(diff(y, t, 1).subs(t, 0))
print(diff(y, t, 2).subs(t, 0))
