import sympy
from sympy import *

t, c1, c2, c3 = symbols('t c1 c2 c3')

yc = c1 * exp(t) + c2 * cos(t) + c3 * sin(t)
Ypt2 = - cos(t) * ( log(cos(t)) + t ) / 2 + sin(t) * ( log(cos(t)) - t ) / 2
y1 = yc + Ypt2 # y_1(t) = everything but the integral term 
print(y1.subs(t, 0)) # y(0)

yp = diff(y1, t, 1) + ( 1 / (2 * cos(t) ) ) # the first derivative of y(t) without the integral term 
print(yp.subs(t, 0)) # y'(0)

ypp = diff(y1, t, 2) + ( sin(t) / ( 2 * cos(t)**2 ) ) + ( 1 / (2 * cos(t) ) ) # the second derivative of y(t) without the integral term 
print(ypp.subs(t, 0))


system = Matrix( ( (1, 1, 0, 2), 
                   (1, 0, 1, -1), 
                   (1, -1, 0, 1) ) )
print(solve_linear_system(system, c1, c2, c3))

