import sympy
from sympy import *

t, c1, c2, c3 = symbols('t c1 c2 c3')

y1 = c1 + c2 * exp(t) + c3 * exp(-t) - log(tan(t/2)) # y_1(t) = everything but the integral terms (they vanish when I evaluate at t=pi/2)
print(y1.subs(t, pi/2)) # y(pi/2)

yp = diff(y1, t, 1) + ( 1 / sin(t) ) # the first derivative of y(t) without the integral terms (they vanish when I evaluate at t=pi/2)
print(yp.subs(t, pi/2)) # y'(pi/2)

ypp = diff(y1, t, 2) - ( cos(t) / ( sin(t)**2 ) ) # the second derivative of y(t) without the integral terms (they vanish when I evaluate at t=pi/2)
print(ypp.subs(t, pi/2))

