import sympy
from sympy import *

t, u1p, u2p, u3p = symbols('t u1p u2p u3p')

system = Matrix( ( (exp(t), cos(t), sin(t), 0),
                   (exp(t), -sin(t), cos(t), 0),
		   (exp(t), -cos(t), -sin(t), exp(-t)*sin(t)) ) )
print(solve_linear_system(system, u1p, u2p, u3p))

# Integrating these (multiplied by 20) we get:
#
u1 = -2 * exp(-2*t) * ( 2 * sin(t) + cos(t) ) 
u2 = -2 * exp(-t) * ( sin(2*t) - 3*cos(2*t) + 5 ) 
u3 = 2 * exp(-t) * ( 3 * sin(2*t) + cos(2*t) + 5 ) 
print(simplify( exp(t) * u1 + cos(t) * u2 + sin(t) * u3 ))

