import sympy
from sympy import *

t, u1p, u2p, u3p, u4p = symbols('t u1p u2p u3p u4p')

u3pc = t*cos(t)
u4pc = t*sin(t)

system = Matrix( ( (cos(t), sin(t), u3pc, u4pc, 0),
                   (-sin(t), cos(t), diff(u3pc, t, 1), diff(u4pc, t, 1), 0),
                   (-cos(t), -sin(t), diff(u3pc, t, 2), diff(u4pc, t, 2), 0),
                   (sin(t), -cos(t), diff(u3pc, t, 3), diff(u4pc, t, 3), sin(t))
               ) )
print(solve_linear_system(system, u1p, u2p, u3p, u4p))

# The integrals above mulitplied by 16:
# 
u1 = -4*t + 3*sin(2*t) - 2*t*cos(2*t)
u2 = 2*t**2 - 3*cos(2*t) - 4*t*sin(t)*cos(t) - 2
u3 = 2*cos(2*t)
u4 = 2*(sin(2*t) - 2*t) 

Y = u1 * cos(t) + u2 * sin(t) + u3 * t * cos(t) + u4 * t * sin(t)
print(simplify(Y)) # need to divide back by 16 to get Y(t)
