source( 'utils.R')

t_max = 4
t = seq( 0, t_max, length.out=500 )
y = u_sub_c( t, 3/2 ) - u_sub_c( t, 5/2 )

#postscript("../../WriteUp/Graphics/Chapter6/sect_4_prob_16_g_plot.eps", onefile=FALSE, horizontal=FALSE)
plot( t, y, type='l', main='Problem 16' )
grid()
#dev.off()


t_max = 40 # a much longer range of time
t = seq( 0, t_max, length.out=1000 )
h = function(t){
    r = 3 * sqrt(7) / 8
    1/4 - (1/4) * exp( -t/8 ) * cos( r * t ) - (1 / (12 * sqrt(7))) * exp( -t/8 ) * sin( r * t )
}

non_k_part = u_sub_c( t, 3/2 ) * h( t - 3/2 ) - u_sub_c( t, 5/2 ) * h( t - 5/2 )

k = 2
u = 4 * k * non_k_part

plot( t, u, type='l', xlab='t', ylab='y(t)' )
#abline( v=c(3/2, 5/2), col='red' )
grid()

# Plot this for k = 1/2, 1, and 2:
#
k = 1/2
u_onehalf = 4 * k * non_k_part

k = 1
u_one = 4 * k * non_k_part

k = 2
u_two = 4 * k * non_k_part

#postscript("../../WriteUp/Graphics/Chapter6/sect_4_prob_16_g_all_plots.eps", onefile=FALSE, horizontal=FALSE)
y_rng = range( c( u_onehalf, u_one, u_two ) )
plot( t, u_onehalf, col='green', type='l', xlab='t', ylab='y(t)', ylim=y_rng ) 
lines( t, u_one, col='blue', type='l' )
lines( t, u_two, col='red', type='l' )
grid() 
legend( 'topright', c('k=1/2', 'k=1', 'k=2'), lwd=2, lty=c(1, 1, 1),
col=c('green', 'blue', 'red') )
#dev.off()


# Find the smallest value of k such that u(t) reaches the values of 2:
#
mnk = max( non_k_part )
smallest_k = 2 / ( 4 * mnk )
print(sprintf('smallest k= %.3f', smallest_k))

# Find the time tau after which |u(t)| < 0.1 for all tau (when k=2)
#
below_t = abs( u_two ) < 0.1

# Walk backwards until we get the first FALSE:
#
t_index = length(u_two)
while( below_t[t_index] ){
    t_index = t_index-1
}
print(sprintf('tau= %.3f', t[t_index+1]))


