
A = matrix(c(-1/10, 3/40, 1/10, -1/5), nrow=2, ncol=2, byrow=T)
print(eigen(A))

A = matrix(c(1, 3, -2, 2), nrow=2, ncol=2, byrow=T)
solve(A, c(-17, -21))

ts = seq(0, 100, length.out=100)

x1 = (29/8) * (+1) * exp(-ts/4) - (55/8) * (+3) * exp(-ts/20)
x2 = (29/8) * (-2) * exp(-ts/4) - (55/8) * (+2) * exp(-ts/20)

#postscript("../../WriteUp/Graphics/Chapter7/chap_7_sect_5_prob_30_plot.eps", onefile=FALSE, horizontal=FALSE)
par(mfrow=c(1, 2))

plot(x1, x2, type='l')
points(c(-17), c(-21), type='p', cex=1.5, pch=19)
grid()

x_min = min( c(x1, x2) )
x_max = max( c(x1, x2) ) 
plot(ts, x1, type='l', col='green', ylim=c(x_min, x_max), xlab='time', ylab='x')
points(ts, x2, type='l', col='red')
points(c(0, 0), c(-17, -21), type='p', cex=1.5, pch=19, col=c('green', 'red'))
legend('bottomright', c('x1', 'x2'), col=c('green', 'red'), lty=c(1, 1))
grid()

par(mfrow=c(1, 1))
#dev.off()


# Part (c): Approximate the value of T:
# 
ts = seq(0, 100, length.out=10000)

x1 = (29/8) * (+1) * exp(-ts/4) - (55/8) * (+3) * exp(-ts/20)
x2 = (29/8) * (-2) * exp(-ts/4) - (55/8) * (+2) * exp(-ts/20)

mask = (abs(x1) < 0.5) & (abs(x2) < 0.5) 
first_crossing = which(mask)[1]
print(sprintf('T= %10.6f', ts[first_crossing]))
