source('../Chapter2/euler.R')

t0 = 0 
y0 = 1
t1 = 0.2
h = 0.1

# Where do we want to evaluate the solution:
#
t_grid = seq( t0, t1, by=h )

# Eulers method:
#
dy.dt = function(t, y){ 1 - t + 4*y } 

res = euler(dy.dt, h=h, start=t0, y0=y0, end=t1)

# Iterate the higher order Taylor's expression:
#
ho_taylor = function(y_n, t_n, h){
    y_n + ( 1 - t_n + 4 * y_n ) * h + ( 3 - 4 * t_n + 16 * y_n ) * ( h^2 / 2 )
}
y1 = ho_taylor(y0, t0, h)
y2 = ho_taylor(y1, t0+h, h)
ho_taylor_res = c(y0, y1, y2)

# The exact solution:
# 
y_exact_fn = function(t){ (4*t - 3)/16 + (19/16)*exp(4*t) }
y_exact = y_exact_fn(t_grid)

# Save the results:
#
A = rbind( res$ys, ho_taylor_res, y_exact )
rownames(A) = c( 'Euler', 'HO Taylor', 'Exact' )
colnames(A) = t_grid
print(A)
