# I the function knn.reg to evaluate the numerical solution at a fixed grid of points
#
if( !require('FNN') ){
    install.packages('FNN', dependencies=TRUE, repos='http://cran.rstudio.com/')
}
library(FNN)

source('../Chapter2/euler.R')

t0 = 0
y0 = 1
t1 = 0.4

# Where do we want to evaluate the solution:
#
x_grid = seq( t0, t1, by=0.1 )

h = 0.05

# The rounded Eulers method:
#
dy.dt = function(t, y){ 1 - t + 4 * y }
res = rounded_euler(dy.dt, h=h, start=t0, y0=y0, end=t1, n_digits=2)
e_yhat_part_a = knn.reg( as.matrix( res$xs ), y=res$ys, test=as.matrix( x_grid ), k=1, algorithm='brute' )

dy.dt = function(t, y){ 3 + t - y }
res = rounded_euler(dy.dt, h=h, start=t0, y0=y0, end=t1, n_digits=2)
e_yhat_part_b = knn.reg( as.matrix( res$xs ), y=res$ys, test=as.matrix( x_grid ), k=1, algorithm='brute' )

dy.dt = function(t, y){ 2*y - 3*t }
res = rounded_euler(dy.dt, h=h, start=t0, y0=y0, end=t1, n_digits=2)
e_yhat_part_c = knn.reg( as.matrix( res$xs ), y=res$ys, test=as.matrix( x_grid ), k=1, algorithm='brute' )

A = rbind( e_yhat_part_a$pred, e_yhat_part_b$pred, e_yhat_part_c$pred )
rownames(A) = c( 'Part (a):', 'Part (b):', 'Part (c):' )
colnames(A) = x_grid
print(A)

