# I use the function knn.reg to evaluate the numerical solution at a fixed grid of points
#
if( !require('FNN') ){
    install.packages('FNN', dependencies=TRUE, repos='http://cran.rstudio.com/')
}
library(FNN)

source('modified_euler.R')

t0 = 0.0
y0 = 2.0
t1 = 0.4

# Where do we want to evaluate the solution:
#
x_grid = seq( t0, t1, by=0.1 )

dy.dt = function(t, y){ 5*t - 3*sqrt(y) }

h=0.05
res = modified_euler(dy.dt, h=h, start=t0, y0=y0, end=t1)
ie_yhat_hl = knn.reg( as.matrix( res$xs ), y=res$ys, test=as.matrix( x_grid ), k=1, algorithm='brute' )

A = rbind( ie_yhat_hl$pred )
rownames(A) = NULL
R = cbind( c( 0.05 ), A )
colnames(R) = c( 'h', sprintf( 'y(%.2f)', x_grid ) )
print(R)
