
t0 = 0.9
t1 = 0.93175
y0 = 3.4298

t_grid = seq( t0, t1, length.out=500 )

phi_1 = -log( ( 1 + exp(-y0) ) * exp(t0 - t_grid) - 1 )
phi_2 = -log( t0 - t_grid + exp(-y0) )

#postscript("../../WriteUp/Graphics/Chapter8/chap_8_sect_6_prob_2_plots.eps", onefile=FALSE, horizontal=FALSE)
y_min = min( c(phi_1, phi_2) )
y_max = max( c(phi_1, phi_2) )
plot(t_grid, phi_1, 'l', col='green', xlab='t', ylab='phi(t)', ylim=c(y_min, y_max))
lines(t_grid, phi_2, 'l', col='blue')
legend('topleft', c('phi_1', 'phi_2'), lty=c(1, 1), col=c('green', 'blue'))
grid()
#dev.off()
