if( !require('phaseR') ){
    install.packages('phaseR')
}
library(phaseR)
library(deSolve)

source('../Chapter3/utils.R')

my_yprime = function(t, y, parameters) {
    xt = y[1]
    yt = y[2]
    dy = rep(NA, length(y))
    dy[1] = 1 - (parameters$b + 1) * xt + xt^2 * yt / 4 
    dy[2] = parameters$b * xt - xt^2 * yt / 4
    list(dy)
}

# Part (e):
#
#postscript('../../WriteUp/Graphics/Chapter9/chap_9_sect_7_prob_20_part_e_plot.eps', onefile=FALSE, horizontal=FALSE)

t.end = 20.0

# b=1:
#
diff_eq_params = list(b=1)
cp_x = 1
cp_y = 4*diff_eq_params$b
CP = data.frame(x=cp_x, y=cp_y)

par(mfrow=c(1, 2))

flowField(my_yprime, x.lim = c(-0.5, 8), y.lim = c(-0.5, 7), parameters = diff_eq_params, points = 21, add = FALSE, xlab='x', ylab='y', main=sprintf('b= %.2f', diff_eq_params$b) )
trajectory(my_yprime, y0 = c(3, 6), t.end = t.end, parameters = diff_eq_params, col='blue', pch=19)
points(CP$x, CP$y, pch=19)


# b=3/2:
#
diff_eq_params = list(b=3/2)
cp_x = 1
cp_y = 4*diff_eq_params$b
CP = data.frame(x=cp_x, y=cp_y)

flowField(my_yprime, x.lim = c(-0.5, 8), y.lim = c(-0.5, 7), parameters = diff_eq_params, points = 21, add = FALSE, xlab='x', ylab='y', main=sprintf('b= %.2f', diff_eq_params$b) )
trajectory(my_yprime, y0 = c(3, 6), t.end = t.end, parameters = diff_eq_params, col='blue', pch=19)
points(CP$x, CP$y, pch=19)

par(mfrow=c(1, 1))

#dev.off()


# Part (f):
#
#postscript('../../WriteUp/Graphics/Chapter9/chap_9_sect_7_prob_20_part_f_plot.eps', onefile=FALSE, horizontal=FALSE)

t.end = 30.0

bs = (5/4) * c(1.1, 1.5, 2.0)
par(mfrow=c(1, length(bs)))
for( b in bs ){
    diff_eq_params = list(b=b)
    cp_x = 1
    cp_y = 4*diff_eq_params$b
    CP = data.frame(x=cp_x, y=cp_y)

    flowField(my_yprime, x.lim = c(-0.5, 15), y.lim = c(-0.5, 15), parameters = diff_eq_params, points = 21, add = FALSE, xlab='x', ylab='y', main=sprintf('b= %.2f * (5/4)', diff_eq_params$b/(5/4)) )
    trajectory(my_yprime, y0 = c(3, 6), t.end = t.end, parameters = diff_eq_params, col='blue', pch=19)
    points(CP$x, CP$y, pch=19)
}

par(mfrow=c(1, 1))

#dev.off()
